*
* ScreenMethods.PRG
*
* Fred Taylor - ElZorro 4/10/2001  www.elzorro.org
*   with thanks to "Michel Roy" <roym@jonar.com> from the
*   News Group microsoft.public.fox.programmer.exchange
*   Subject: Re: Centering Picture in _SCREEN  ( or modifying _SCREENMethods )
*
* Use the following to modify _SCREEN methods:
*
* For VFP6 & 7:
*
*     _SCREEN.NewObject("oSH","ScreenHook","screenmethods.prg")
*
* For VFP3 & 5:
*
*     SET PROCEDURE TO screenmethods ADDITIVE
*     _SCREEN.AddObject("oSH","ScreenHook")
*
* Most of the main VFP screen methods can be hooked into in this manner.
* A similar technique can also be used to hook methods of grid
* headers, etc., at run-time.
*

#IF VAL(LEFT(VERSION(4), 2)) >= 8
	*  8   - BINDEVENT() . oHandler   Priv  Mainv.prg
	oHandler = NEWOBJECT("ScreenHook8", "MovingSplash.prg")
	BINDEVENT(_SCREEN,"Resize", oHandler,"MyResize")
#ELSE
	IF TYPE('_screen.osh')='U'
		_SCREEN.NewObject("oSH", "ScreenHook", "MovingSplash.prg")
	ENDIF
#ENDIF


DEFINE CLASS ScreenHook AS CUSTOM
oScr = _SCREEN
InitialScreenHeight = _SCREEN.Height	&&  =oScr.Height  
InitialScreenWidth  = _SCREEN.Width

PROCEDURE oScr.Resize()
*   THIS.oSH - .   WaitWind  Destroy()
IF VARTYPE(THIS.oSH) = 'U'
	RETURN
ENDIF

local lnHeight, lnWidth, llAllowResizingScreen
llAllowResizingScreen = .T.
*       ,       Screen:
IF VARTYPE(oForm1) = 'O' AND !ISNULL(oForm1)
	llAllowResizingScreen = oForm1.AllowResizeApp
ENDIF

WITH THIS
	IF llAllowResizingScreen = .T.
		lnHeight = .Height - .oSH.InitialScreenHeight
		lnWidth  = .Width  - .oSH.InitialScreenWidth
		.MyMovingSplash(lnHeight/2, lnWidth/2)
		.oSH.InitialScreenHeight = .Height
		.oSH.InitialScreenWidth  = .Width
	ELSE
		*  :
		.Height = .oSH.InitialScreenHeight
		.Width  = .oSH.InitialScreenWidth
	ENDIF
ENDWITH
ENDPROC

PROCEDURE oScr.MyMovingSplash()
LPARAMETERS tnHeight, tnWidth
IF VARTYPE(oFrmWait) = 'O' AND !ISNULL(oFrmWait)
	WITH oFrmWait
		.Top  = .Top  + tnHeight
		.Left = .Left + tnWidth
		.nTop = .Top
	ENDWITH
ENDIF
ENDPROC

ENDDEFINE
*---------------------------------!

DEFINE CLASS ScreenHook8 AS CUSTOM
InitialScreenHeight = _SCREEN.Height	&&  =oScr.Height  
InitialScreenWidth  = _SCREEN.Width

PROCEDURE MyResize()

#IF VAL(LEFT(VERSION(4), 2)) >= 8
	IF NOT ( VARTYPE(oFrmWait) = 'O' AND !ISNULL(oFrmWait) )
		UNBINDEVENT(THIS)
		RETURN
	ENDIF
#ENDIF

local lnHeight, lnWidth, llAllowResizingScreen
llAllowResizingScreen = .T.
*       ,       Screen:
IF VARTYPE(oForm1) = 'O' AND !ISNULL(oForm1)
	llAllowResizingScreen = oForm1.AllowResizeApp
ENDIF

WITH THIS
	IF llAllowResizingScreen = .T.
		lnHeight = _SCREEN.Height - .InitialScreenHeight
		lnWidth  = _SCREEN.Width  - .InitialScreenWidth
		.MyMovingSplash(lnHeight/2, lnWidth/2)
		.InitialScreenHeight = _SCREEN.Height
		.InitialScreenWidth  = _SCREEN.Width
	ELSE
		*  :
		_SCREEN.Height = .InitialScreenHeight
		_SCREEN.Width  = .InitialScreenWidth
	ENDIF
ENDWITH
ENDPROC

PROCEDURE MyMovingSplash()
LPARAMETERS tnHeight, tnWidth
IF VARTYPE(oFrmWait) = 'O' AND !ISNULL(oFrmWait)
	WITH oFrmWait
		.Top  = .Top  + tnHeight
		.Left = .Left + tnWidth
		.nTop = .Top
	ENDWITH
ENDIF
ENDPROC

ENDDEFINE
*---------------------------------
